%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function loadJavaObjects()
	m = methods('com.ibm.rational.rdm.simulinkintegration.manage.DMConnection');
	if isempty(m) == 0
		%java objects already loaded, no need to load
		return;
	end

    myPath = mfilename('fullpath');
    slashedPath = regexprep(myPath, '\\', '/');
    javalib = regexprep(slashedPath, 'mscripts/loadJavaObjects', 'domains/simulink/bin');
    
    files = dir(javalib);
    nfiles = size(files);

    % add libraries to java path
	warning('off', 'MATLAB:javaclasspath:jarAlreadySpecified');
    for x = 1:nfiles
        filename = files(x).name;
        if strcmp(filename,'.') == 0 && strcmp(filename,'..') == 0
			javaaddpath(strcat(javalib,'/', filename));
	    end
    end
	warning('on', 'MATLAB:javaclasspath:jarAlreadySpecified');
end
