%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function lockSimulinkModelInDM()
	postSaveFcn = get_param(gcs, 'PostSaveFcn');
	if strcmp(postSaveFcn, 'saveSimulinkModelToDM()') == 0
		disp('Model is not connected to DM, can not lock model');
		return;
	end
	
	try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		return;
	end	
	
	simMdlName = get_param(gcs,'name');
	if dmConn.isSimulinkModelLocked(simMdlName) == 1
		msg = 'Model already locked';
		lockedBy = char(dmConn.getLockedByInfo(simMdlName));
		if isempty(lockedBy) == 0
			msg = sprintf('%s by %s', msg, lockedBy);
		end
		disp(msg);
		return;
	end	
	
	if dmConn.isSimulinkModelInSyncWithServer(simMdlName) == 1
		action = 'Lock';
	else	
		action = char(dmConn.openLockingModelDialog());
	end
	
	if isempty(action) == 0
		if strcmp(action, 'Open') == 1
			openSimMdlFromDM();
		else 
			if dmConn.lockSimulinkModel(simMdlName) == 1
				msg = sprintf('Succeeded locking model %s on DM.', simMdlName); 
			else
				msg = sprintf('Failed locking model %s on DM.', simMdlName); 
			end	
			disp(msg);
		end	
	end
end