%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function moveSimulinkModelToDM()
	try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		return;
	end	

	sysName = get_param(gcs,'name');
	moveToAction = char(dmConn.openMoveToDMDialog(sysName));
	if isempty(moveToAction) == 1
		return;
	end	
		
	msg = sprintf('Moving %s to DM...',sysName); 
	disp(msg);
	
	bSuccess = uploadSimulinkModelToDM();
	if bSuccess == 1
		set_param(gcs,'PostSaveFcn','postOpenFromDMActions()');
		save_system(gcs);
			
		disp('Move to done.');
		
		%last, lock the model since save/moveto release the locking
		if strcmp(moveToAction, 'MoveToAndLock') == 1
			dmConn.lockSimulinkModel(sysName);
		end	
	else
		disp('Failed to move model to DM');
	end		
end