%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function openSimulinkModelFromDM()
	
	try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		fprintf('ERROR: java object (DMConnection) allocation failed\n');
	else
		downloadedSimMdl = char(dmConn.downloadSimulinkModel());
		if isempty(downloadedSimMdl) == 0
			if strcmp(downloadedSimMdl, 'cancel') == 1
				return;
			end	
			
			disp('Opening model...');
			load_system(downloadedSimMdl);
			postSaveActions = get_param(gcs, 'PostSaveFcn');
			if isempty(postSaveActions) == 1
				set_param(gcs,'PostLoadFcn','postOpenFromDMActions()');
				save_system(gcs);
				close_system(gcs);
			end
			open_system(downloadedSimMdl);
			disp('Opening model done.');
		else
			disp('Failed to get model from DM');
		end
	end		
end

