%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function saveSimulinkModelToDM()
	try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		return;
	end	
	
	%check if we need to save and if model is locked on server before save
	dirtyFlag = get_param(gcs,'dirty');
	if strcmp(dirtyFlag, 'off') == 1
		return;
	end	
	simMdlName = get_param(gcs, 'name');
	if dmConn.canSaveSimulinkModelOnDM(simMdlName) == 0
		return;
	end	
		
		
	sysName = get_param(gcs,'name');
	msg = sprintf('Saving %s to DM...',sysName); 
	disp(msg);

	bSuccess = uploadSimulinkModelToDM();
	if bSuccess == 1
		disp('Saving done.');
			
		%last, lock the model since save release the locking
		dmConn.lockSimulinkModel(sysName);
	else
		disp('Failed to save model to DM');
	end		
end